#!/bin/sh
#
#    Upgrade IQM agent software on IP-PLUG from Linux
#
#    Copyright (C) 2008-2014 Sergey A.Eremenko (eremenko.s@gmail.com)
#    Copyright (C) 2008-2014 Net-Probe, Llc (info@net-probe.ru)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

BASE64=`command -v base64`
MD5SUM=`command -v md5sum`
IQMA_PKG="$1"
HOST="$2"

if [ -z "${BASE64}" ] ; then echo CANNOT FOUND base64 >&2 ; exit 2 ; fi
if [ -z "${MD5SUM}" ] ; then echo CANNOT FOUND md5sum >&2 ; exit 2 ; fi
if [ -z "${IQMA_PKG}" -o ! -f "${IQMA_PKG}" ] ; then echo CANNOT FOUND iqma package >&2 ; exit 2 ; fi
if [ -z "${HOST}" ] ; then HOST=192.168.1.1 ; fi
IQMA_BASE="${IQMA_PKG}".base

echo '/bin/dash' >"$IQMA_BASE"
echo 'cd /var/cache/apt' >>"$IQMA_BASE"
echo "/bin/cat <<-EOFEOD |base64 -d >/var/cache/apt/$IQMA_PKG" >>"${IQMA_BASE}"
${BASE64} ${IQMA_PKG} >>"${IQMA_BASE}"
echo 'EOFEOD'>>"${IQMA_BASE}"
echo 'echo "'`${MD5SUM} -b ${IQMA_PKG}`"\" >/var/cache/apt/${IQMA_PKG}.md6">>"${IQMA_BASE}"
echo 'if ! md5sum -c '"/var/cache/apt/${IQMA_PKG}.md6"' ; then echo DPKG INVALID! ; rm '"/var/cache/apt/${IQMA_PKG}"' ; else echo DPKG OK ; fi'>>"${IQMA_BASE}"

cat "${IQMA_BASE}" | ssh root@${HOST}

exit 0
